# bootable containers initiative meeting - 2025-03-04

## Attendees

- Jason Brooks
- Colin Walters
- Hristo Marinov
- Dusty Mabe
- Miguel Martin
- Micah Abbott
- John Eckersberg
- Robert Sturla
- David Cantrell
- Evan Goode

## Agenda

https://gitlab.com/fedora/bootc/tracker/-/issues/?label_name%5B%5D=Meeting

## Decide who will be writing notes and who will make the meeting notes PR

- Jason 

## Notes

### Local package layering story with bootc & dnf5
#### https://gitlab.com/fedora/bootc/tracker/-/issues/4
- Colin: bootc should be a framework, but not a build system
  bootc emphasizes managing multiple machines, scale out, building containers on remote machine
- Dusty: Important aspect of this user story: you've made local changes via layering, what happens when updates come in
- Colin: dnf is unaware when run in podman, docker, etc. Difficult to wire together the various layers to allow for cache invalidation or general awareness of state. rpm-ostree did A LOT to make this happen.

- dnf demo recording (ck for timestamp) https://www.youtube.com/watch?v=GT8bNaeHuy8

- what are the common issues / pitfalls we encounter w/ this story?
- Evan: dnf should not be a build system for containers. would prefer that dnf just manages installing packages. decisions on what has changed would preferably live somewhere else.
- Colin: strawman: https://github.com/rpm-software-management/dnf5/issues/833#issuecomment-2000244607
  - RPMs you get are strictly pinned to the version of the container image. i.e. Amazon AMI use case
  - https://github.com/rpm-software-management/dnf5/issues/833#issuecomment-2066630575
- Dusty: we wouldn't have this versioning problem if we had version locking on the repos
- Dusty: do we want to consider the local user override scenario (e.g. non-RPM content) as part of the dnf support case? (i.e. cosa + overrides/rootfs - hhttps://coreos.github.io/coreos-assembler/working/#using-overrides)
- Evan: multiple local layers, for rpm and non-rpm elements?
- Item from Jonathan, via Dusty: is something driving bootc, or is bootc driving something? If an update comes in, does our layer get propagated forward?
	https://gitlab.com/fedora/bootc/tracker/-/issues/4#note_1914784365

	
- echo 'foorpm' > /etc/somefile
- bootc apply-local-layer 
- [In the case that bootc is driving local layering]
- bootc upgrade
    - bootc download the new payload
        - call the local layering thing with the new payload as an input
        - local layering thing 
egoode: something like a `bootc local-rebuild` to call out to "local package layering thing" and rebuild and switch without pulling new base images?

- [In the case that something else is driving bootc for local layering]
- 

- rpm db diffing -- where would something like this happen?

- Can we agree on next steps?

- Where are we headed, overall? For instance, is the idea that we're trying to enable a world where bootc-based systems are the default, and Fedorans don't necessarily notice?

- Vote on does bootc drive things, or does something drive bootc?


## **poh-xmxm-qyc (2025-03-04 16:04 GMT+1) \- Transcript**

### **Attendees**

Colin Walters, David Cantrell, Dusty Mabe, Dusty Mabe's Presentation, Evan Goode, Hristo Marinov, Jason Brooks, John Eckersberg, Micah Abbott, Miguel Martin, Robert Sturla, vbatts

### **Transcript**

Jason Brooks: This is where we have the bed we have been using and this is where I am filling out the attendee list and whatnot. We're also recording now.

Colin Walters: All right, I will take a stab at this a lot of discussion but I'll just summarize. I think we started all this right RPJ is I think almost 10 years old now.  I haven't even checked the whole idea of having an image base by default but being able to locally override packages as we kind of talked about for a lot is really creates a hybrid system where it's like okay I run this well tested base but I can tweak it for my VPN or whatever and we talked about this and there's a lot involved in how RPM makes this work it's very very complicated

Colin Walters: ated across a whole bunch of things and with bootc we're really trying to shift and it's really a totally different thing where we're shifting the emphasis to you build a container image on a remote machine right that you scale out and this and kind of where some of this crossed right is we never were on the server side build on the RP side before the container we didn't really emphasize custom builds a lot. There's a lot of people that did it successfully, but yeah, a lot of history here. core OS didn't emphasize you building a custom thing. Cor is all about ignition. We spor anyways A whole lot of history here. And I think there's a lot of hard work to create a compelling experience to do local builds with bootc and DNF other tools.

Colin Walters: I guess I will say as a framing thing from my point of view in this kind of new design I'd love to just provide the framework but I don't think bootsy should become a build system right it's kind of core to what I'm thinking is like you build an OCI we will boot it right but we're not a build system I mean there's boots container lint but yeah whatever however you choose to build your OCI and again whether that' maybe you use Nixos to build part of it  maybe use basil or whatever it is, right, that you want to use. but obviously we want to have really really good integration with other things. I think that's my spiel on this.

Dusty Mabe: So let me make a statement and see if we agree and then I think that kind of controls a little bit how much responsibility boot has. so one of the most important features I think this user story I guess encompasses is you've made local changes to your system through this layering mechanism. What happens when new updates come in? Right?

Dusty Mabe: So I would propose that when new updates come in, it essentially needs to drive itself, so when you make a local change using something like what Evan demoed last week, when there's a new update in the registry, that shouldn't blow away what your local change was, that delta should be carried forward. so do we agree that that's a fundamental feature of this thing? And I think if we do, then that kind of dictates …

Evan Goode: I agree with that.

Dusty Mabe: will help frame what responsibility bootc has.

Colin Walters: Yeah, to build on that, the way I would say this is if you don't have that, the user experience is awful because you don't know whether an update is meaningful. this is the thing I could talk about for an entire hour is correct change detection, cache invalidation.  I mean the way I always love to say it right is when DNF is run inside podman or docker it has no idea there is almost no special casing it's just unaware it just doesn't know right it might as well be a virtual machine for all it knows and similarly podman and docker completely unaware of what's going on inside right that was the sort of core principle you type a run invocation hands off pod man and docker have no idea and cache invalidation

#### 00:05:00

Colin Walters: to drive it and correct change detection, you kind of need to wire all of these layers together and RPM most goes to a lot of effort to do exactly what you said there's a lot of input hashing and without going into a lot of the detail right almost anyone who ends up with a container build system ends up dealing with this one way or the other kind of the way we do it for the base images today not in Fedora but in coffees is we have an RPM lock file which kind of

Colin Walters: That's our change detection or one baseline for it. But there's a whole lot here. And kind of one of the real challenges in all of this is creating a system that works both on a server to build images for multiple machines and is efficient client side on a single machine. It's actually really hard. we can do it.  We have those tools. but it is hard.

Dusty Mabe: So it seems like we had large agreement there, but Colin, you were kind of summarizing some of the pitfalls that we will eventually have to encounter and overcome as part of doing that. Is that what you were kind of trying to summarize? So for example today if you podman build a container and It pulls in a DNF, it does a DNF command. Obviously, it's talking to the repos, And pulling the version of the RPMs at that point in time. And if you run it again tomorrow, do you want to invalidate that what you did yesterday because there might be a new version of the repos today or not? Right?

Dusty Mabe: And I think some ways we deal with that today is Podman has a cache TTL parameter where you can specify a time. and I don't know if we would want to incorporate something like that or DNF itself under the hood would do something smarter based on that. But yeah, I think maybe we should collect some of the common thing things that we will encounter as part of this effort and then maybe we can address them look at them oneonone at some point.

Dusty Mabe: I'm wondering so okay go ahead Evan.  Yeah.

Evan Goode: …

Evan Goode: I just wanted to talk about I guess DNFS, what I expect for DNF. and like Colin said for bootc, I also kind of don't think that DNF should be a build system for containers. there are certain things that we could do to make DNF more aware and integrate better. and if we want persist to work in somewhere close to how I kind of am imagining, we'll need to have it call out to bootc and call out to whoever is building the container.

Evan Goode: but I would like if DNF's job in this were just to kind of manage the RPM packages that are going into the container and then kick off to some other tool to say build a container if enough has changed. I kind of just want those decisions out of DNF.  I mean, every developer wants the hard stuff out of their project, I guess. But, yeah.

Colin Walters: I think I agree with that. we're kind of here also because today talks to RPMs and OS3 and containers. It does all three and it is a build system and yeah, we just kind of hit scaling problems with it in the whole shift to containers and I don't know what the declarative front end should look like all this stuff. How you handle nonRPM content big thing wrapped up in all this.  But the more I think about this, one thing I would straw man for this as a baseline. there's whole subsections of this problem domain, but I do want to keep this thing in our minds. I linked to it, but it's basically one of my favorite topics when you talk about RPMs and containers. and it's basically solving the drift problem and the change detection problem in one way.

#### 00:10:00

Colin Walters: If basically in a nutshell we made it so the RPMs you get are always pinned to the version of the container image you get. In other words, we strictly bind these two. And again as I talk about Amazon Linux is doing this today. When you boot the Amazon Linux ammy and you type dnf install you will always get the same version of a package starting from the same ammy.  if you can of course force things to override and float but it creates a mental model of predictability right and I think that's part of this so basically that helps so much with the change detection problem both on the server side and on the client I could stand up for an hour and talk about dealing with the differences between RPMs and containers

Colin Walters: and the challenges there. but this one would really help because again on the client side if you don't have a new image then you never have new RPMs yet. The problem of course comes when you starts talking about third party repositories and yeah there's some challenges there but at least

Dusty Mabe: The other problem there too is at least with things like Fedora. I don't know. it all depends. We obviously have this problem in core OS where we don't release every day but the Fedora repos get spun every day and we end up so yeah something like that would help us,  because we would only get the versions of RPMs that were built with the stable build that happened a week ago. That's definitely a change on Fedora's infraide.

Dusty Mabe: Our intermediate solution to that problem was we create an updates archive repo that has all the old versions of packages in it and then RPMos tree was smart enough to pass options to DNF to say hey choose the version that matches one of these locked bit base packages but yeah if we wouldn't really need lock files or anything if we had version locking on our  repose essentially. Okay.

Dusty Mabe: So excluding obviously DNF doesn't want to be a container build system in my MVP and…

Dusty Mabe: I think you even demoed something didn't you Evan where DNF was kind of leveraging Podman to do the build right that's okay handwaving starts the conversation yeah hand waving starts the conversation.

Evan Goode: That's kind of…

Evan Goode: how it works in my head. I did a lot of handwaving. So something builds the container file. Yeah.

Dusty Mabe: But yeah, so at a basic level, it's something telling Podman, here's what to build and podman does a build and now it's available, right? so at its most basic level, it's additional RPMs to add to a system. but are there other features that we want to consider as part of this proposal? the MVP could just be you add an RPM. I think Colin mentioned nonRPM content at one point I think in maybe the last comment on that number four issue.

Dusty Mabe: So for example, non RPM content to me would be either things like commands in a container file that are in addition to your RPMs that you want to add or remove. So anything like run systemctl enable, that type of thing. or we could have a basic structure where you can copy in things.

Dusty Mabe: so in Kosa today when we want to do a build where we override some of the content in the base layer even add we have a directory called overrides FS and KOSA will just pick that content up right and it's really only for local developer builds but it's kind of useful if you want to override the version of bash in this

#### 00:15:00

Dusty Mabe: you just put the bash that you want to override in overrides rootf user bin bash, right? So would something like that as part of this system be something we would want to support or we could consider that out of scope initially, we can scope this as small or as large as we like and choose okay this is a phase two feature or something like that.

Colin Walters: I mean, yeah, definitely. I think supporting nonRPM content just as well as RPMs is I mean, it doesn't have to be a requirement, but I think it's an important goal and…

Dusty Mabe: So I think you could do that in a container file, right?

Colin Walters: RP never really tried to do that.

Jason Brooks: But would that be related to the DNF topic? I mean would you be making those sort of changes to modify the image just in a container file? I mean are we talking about another way of making those changes?

Dusty Mabe: The question is this is more of sugar type thing, right? It's okay rather than even have to write a container file, you just put files in a directory and it knows to pick them up, the thing that was doing the layering would kind of just say, …

Dusty Mabe: I see there's files here." So it autogenerate you a container file that would pull that stuff in. Something like that. Evan, go ahead.

Evan Goode: I'm sort of newish to the container space.

Evan Goode: So I don't maybe have a full understanding of the ecosystem here, but it seems my kind of rough proposal of just exposing one imperative container file to the user is maybe not the best design. because we want this local layer to include DNF packages and also kind of possibly user specified run commands and stuff. so I wonder for caching purposes, maybe it would be best to split this into multiple local layers.

Evan Goode: if we had one layer that got built and overlaid that just has the RPM packages managed by DNF and then for the story of the user wants to do whatever run commands install some nonRPM content that could be exposed as a separate container file. so then later if we wanted to change how the DNF layer is built, we wouldn't have to have users edit their custom container file and kind of like keep it maybe a little cleaner.  Okay.

Dusty Mabe: Yeah, I think that makes sense. I mean, it could almost be a plug-in model type thing where you can drop in more things and then by default there are convenience plugins that just exist that would do the thing like, you put files in this overrides directory, let me add them. Right? And if there's no files in there, that plugin does nothing.  write that down. from Jonathan wanted to be here, but he had a conflict that he really couldn't get out of.

Dusty Mabe: One thing that he wanted to or was interested in discussing was a question of is it something driving boot C right for this whole user story or is it boot C driving something and I think based on the conversation or the thing that I brought up originally which was if the new update comes  Then does our layer get propagated forward? Right?

#### 00:20:00

Dusty Mabe: I think let me know if I'm wrong means it kind of needs to be bootc driving something right because how do you check if there's an update available right usually it's booty that's doing that checking today right new container in registry  Okay.

Colin Walters: Yeah, I mean yes, but there's definitely a very fundamental difference between the inherent predictability of calling out to a remote registry, quering some JSON versus executing some arbitrary code may do a build, yeah, I don't know there was a prior discussion which we should link here on supporting bootc as a front end. that would make it clear that something else was driving it. I mean opposition in principle to that for me but it's definitely a lot of details there and I think when you take it out right a lot of cases I feel like would want to go originally to the source of truth right for whatever the system state is.

Colin Walters: Yeah, what that thing puts Yeah, it feels like in the limit it just be boots is just sort of proxying some arbitrary APIs or…

Colin Walters: or something else that is owned by some other tool, So I don't know how far we would go for that, but yeah, I mean as far as the user command line convenience and just Yes, I think boots up. It just makes clear that hey, I'm going to talk to something else. Sure.  I mean, why not? I guess. Yeah.

Dusty Mabe: Yeah, let me share my screen for just a minute.

Dusty Mabe: So let's see if the mental model here that I have matches. So somebody types something like that or maybe it's a timer or something that kind of checks if there's an upgrade available and is supposed to do some action.

Dusty Mabe: so if somebody runs boots upgrade and there is a new container then my thoughts are bootsy would then I guess first download the new payload and then you call the local layering thing with the new payload  and input.

Dusty Mabe: So in my mind the local layering thing wouldn't be reaching out to a registry necessarily to pull from the registry directly to build on top of it would or maybe bootc tells it specifically here hash you need to pull from the registry or something like that but basically boots is the one telling local layering thing here's your starting  point and then it processes and then hands back to boot C the layered thing, And if it fails for whatever reason, we should probably talk about I think the behavior should be the booty upgrade fails.

Dusty Mabe: but I don't know because does the user want us to upgrade the system even though their local layering stuff didn't work or I don't know. Probably not.

Colin Walters: I mean it's not even clear to me in this flow you always want to fetch the new base image whenever you're doing an operation sometimes you won't right pose also exposes that difference today I'm just saying there are use cases…

Dusty Mabe: Say that one more time, Colin. Right.

Colin Walters: where I'm trying to say this right if you  type premise to install on the client side today. We don't go looking for a new base image by default, we don't always look for updates. And that's actually pretty important.

Dusty Mabe: Yeah. I guess in that case it's probably worth talking about what's the initial input to layering and in this case what Evan was saying was echo through RPM into Etsy some file basically right but then how would we trigger

#### 00:25:00

Dusty Mabe: how would we trigger that initial initial layer layering operation, Oopsie apply local layer, So whatever that initial command would be, even if bootc had no new update in the registry, it would just say, apply that on what we currently have. which would be the same as what RPM does, Today. So, if I type RPM install, you just mentioned, it won't actually reach out and try to do an upgrade at the same time. so I think that would be the equivalent of what this would be, which I mean I have no idea what the actual letters should be that somebody types to tell it to do that.

Dusty Mabe: and at the same time I don't know if we should have another thing too is this DNF or is it bootc there's I don't know what the right layer is in order to tell it to do this.  But if boot C is the one who knows what the thing is that we're supposed to start from, it feels natural for it to be boot C and then maybe it's like the plug-in system that I mentioned where actually your build system could be DNF or it could be Nyx like you mentioned earlier Colin or was it Colin that mentioned Nyx or it could be something else.

Dusty Mabe: It doesn't have to be DNF with Podman or it could be an API call, hey Quay, build me this container, right? And then let me download it and I'll hand it back. Evan, go ahead.

Evan Goode: Just wondering…

Evan Goode: if we should maybe think through the alternative where something else is driving things other than bootc. and this is all about Jonathan's comment that is linked somewhere here. But, yeah, if we were to go the route of, bootc being a little dumber and maybe not being aware of the local layering stuff.

Evan Goode: If all bootc is aware of this is the image that I'm switched to and that'll be some local image reference if there are any locally layered packages that kind of means that we might be like throwing out the ability of boots or the interface right if a user wants to switch to a new base image if they don't have any local s  packages layered. If they're not using this new thing, then they'll run bootsy switch as usual. but if they've layered any packages, then the bootc switch is not going to be meaningful because bootc just only knows about this local image. So instead, they would run whatever container build system we decide to go with tool to manage this stuff.

Evan Goode: and then that thing calls bootc switch to switch into the new locally built layer.  To me the bootc being smarter feels a little nicer because it means the interface would be the same regardless of whether you have local packages layered that's more transparent to the user and they don't have to worry about that. but yeah from a point of view of keeping bootc more minimal I definitely see the second option is better.

Colin Walters: If we can go back actually a sort of core principle I want to try and take and I know this increases the scope but I think it's actually pretty important right is the tools and techniques you use to manage a booty system as to the greatest degree possible should align with the tools and techniques that one uses to build application containers.  So yeah, I know this echoes some other debate a bunch of places, but I think that's part of the value proposition, but where this is especially connected is we have a kind of spectrum and toolbox is another thing that very much in my experience falls in this bucket of I got that base image that I want to tweak maybe locally or maybe remotely and in a kind of ideal world and I

#### 00:30:00

Colin Walters: So the people there was a guy that maintained a different toolbox that had actually started on their own declarative spec for creating local toolboxes for basically all the same reason we're talking about here. and so yeah, I mean I know it increases the scope a lot, but I really do want to keep reiterating this because especially if we come up with any DNF magic and container integration. I think that's my point. It would apply to local toolbox builds as well and kind of other things.

Jason Brooks: I kind of keep hoping for just a description of how we want it to be for people. are we trying to make it so that your experience with this stuff is the same as you would have with package based systems right now and so the things that would happen in that world will happen in this world or are there things that are unfortunate about the current package based system world that really in the new awesome future would work a little differently…

Jason Brooks: but I feel like a lot depends on how we want it to be you

Evan Goode: My personal opinion is that I as a user do not care about persist at all and…

Evan Goode: I would much rather have a declarative interface where I just list the packages I want in a file and then rebuild a container from that. But that is one man's opinion.

Evan Goode: and I know there's maybe some pull from other directions that we want a familiar user experience for people.

Colin Walters: Yeah. I mean, Bill, the way the one angle I like to think about this from, right, is doing the least doing the most we can to not invalidate people who get their real certificates. and yeah, what you just said is really a focal point.  I mean I am all on team declarative system state for sure but we kind of haven't really agreed on one of those declarative front ends and everyone knows about the imperative interface to DNF and it's so funny because in RPM most for so many years we bridged this world the build side has a declarative interface the client side did not and it just kept creating this weird tension

Colin Walters: to the point where we started to think about how to expose the declarative side on the client side to you, but then that just became messy and then the container thing happened. but yeah so I do feel in the end we want both and actually I would probably put as a baseline especially just thinking about this with a real point of view on rail hat the most that we can do to make it so that when you type dnf something and the least surprising thing happens that's really good. so if it tells you you do have persistent it's like no go write this file I don't think that I wouldn't call that a problem right but I would kind of lean towards maybe we edit the file for you or…

Dusty Mabe: But I mean,…

Colin Walters: 

Colin Walters: something but Death.

Dusty Mabe: could that old interface be bridged into the new world though? So when somebody calls that command, could we actually trigger the local layer and add it to the definition for the local layer and then trigger that and then apply it live? I guess.

Dusty Mabe: So that would be the same experience that you would have in traditional but it also gets into the de definition of the thing that we're building. Right.

Colin Walters: Yeah, it's basically Yeah,…

Colin Walters: it's basically what RPM does like when you type an imperative command client side, it translates it into one of two internal representations which won't go  in a lot of detail. Both of which have their weird trade-offs. But yes, that is how it works, Internal to RPM, when you type RPG status, this is a super important thing, It's like I want to understand the state of my system. It can show you that because it knows what you wanted, Instead of just trying to like it's actually really complicated how DNF works by default when you upgrade from a package based system, There's this whole user installed database. There's the RPM. It's very complicated,  Whereas our chemistry just starts from that state. It's like I want the space image with these changes basically.

#### 00:35:00

Dusty Mabe: Yeah, I mean selfish me would love to have a nice little summary of…

Dusty Mabe: what the local layer was in the booty output as well. I don't know of the best way to get that, but

Evan Goode: That's something I've been thinking about a little bit.

Evan Goode: That to me feels like DNF's job now that DNF is sort of aware of this overlay FS thing. we could have a DNF command that gives you a diff of the RPM DB that is on some layer and then the RPM DB that's on some other layer. I could see that

Colin Walters: Let me riff on that for a second.  So I think we agreed at you said at the start I kind of agree you didn't want DNF to be like a container build system or anything but I think a kind of looming question especially with the DNF bootsy plugin is to what degree do you feel it would make sense to teach DNF to interact with some container stuff like this kind of came up in a call with a Red Hat customer who wanted basically exactly what we're just talking about let me see the RPM level diff inside a container it probably  shouldn't go in podman, I mean, it could be a podman. I don't know. It's one of those things that's architecturally messy, but we've been dealing with I don't know. I guess I was just kind of question going forward, Is to what degree do we see do we see intersecting the container ecosystem at DNF and just across this board, right?

Dusty Mabe: Yeah, I mean OS3 dealt with this by adding metadata to the commit object, so I don't know if I guess labels are our option mostly for containers have the list of packages there,…

Dusty Mabe: but I think there's limits, right?

Evan Goode: I mean,…

Evan Goode: I like the idea of keeping DNF as dumb as I mean, there's also the question of DNF4 versus five. now in the real development cycle, we're still talking about DNF4 stuff and I would love to punt all this persistent conversation to DNF5 so we don't have to change much in DNF4…

Dusty Mabe: Yep.

Evan Goode: if product management lets us do that. but yeah, it's always nice to think of dumb tools, I guess.

Evan Goode: and have the intelligence be an emerging property. But for this particular case of RPMDB diffing yeah maybe the DNF interface is aware of containers but under the hood it's just like a diff of two databases. I'm not sure. if we had a way to spin up little mounts for the image and then have DNF just treat those as install roots, that might be some option. But yeah, I don't have a strong philosophical view on whether DNF should interact with containers. I guess more of just like a practical thing.

Evan Goode: Yeah, absolutely.

Colin Walters: What could be a plugin too just kind of might make something.

Dusty Mabe: Is there anything else somebody'd like to bring up just about fundamental design exploration?

Dusty Mabe: If not, we can maybe talk a little bit about are there any things out of this discussion that we've had that we can write down as something we agree on or what are next steps that we can agree on to maybe it's more design discussions where we talk specifically about particular pieces of this or

#### 00:40:00

Jason Brooks: One thing I noted down here at some point in the notes is what are the common issues, pitfalls with the story? I mean, that might be good just to write those out somewhere to address. And then I also think the question of are we trying to basically make this a thing where if this were the default for Fedora that current Fedorans could continue with their lives,…

Jason Brooks: or just the sort of a concise statement of how we want it to feel to users. that's something

Dusty Mabe: Jason is that basically…

Dusty Mabe: if a Fedora user unknowingly now it's Fedora 50 and…

Dusty Mabe: they download Fedora workstation and the technology underneath is essentially bootc What would their experience be like? Is that what you're ask? Yeah.

Jason Brooks: Yeah, that could be one way of looking at it.

Jason Brooks: I know a thing that's come up a lot with silver blue and things should this be the default Fedora workstation? should we look at this? that's one way of looking at it. If that's the future we want then or like I said before are there things about that current way that people expect things that really should change…

Dusty Mabe: Mhm. Yeah.

Jason Brooks: but that'll give a lot of structure to our next steps.

Evan Goode: Could we maybe I don't know get a quick thumbs thumbs down one way or the other about whether bootc is the thing driving the local builds or whether something else is driving bootc.

Evan Goode: if everybody's on the same page about the two options there

Colin Walters: I mean I'm very much on the team ladder the second something else should drive booty but we'll make it clear on the bootsy side that something else is driving it that's my head the other thing I would definitely reiterate here is I do think a unified storage is going to be really important for this in terms of the container build system the booted host which glossing over but the second one again I know I think I mentioned this thread

Colin Walters: It's just you really do it would be very helpful for this although not a hard requirement to also have unified storage for the cached RPMs pristine ones and again this is what RPM does every upgrade is a kind of fresh install is a sort of core principle that we try and maintain where the kind of pristine file system trees are reunioned  client side, we don't just take whatever we found on disk and mutate it, right? We're always reassembling. And so to achieve that didn't require some kind of deeper changes to the ARM stack, but it's really useful because that way you never trying to figure out how to say this in a really simple way.

Colin Walters: It's as someone who's choosing an imagebased system, I'm doing it because I often got burned in the past by this one system drifted because the CIS admin SSH in to that one system to do some debugging and left over some stuff. They changed a cis cuddle or whatever, and that wasn't clear or it's like I have an old blog post about this one but you can get some insidious traps with anible line and file where it creates hysteresis and state right it's so to the greatest degree possible right we want to avoid retaining state accidentally and…

Colin Walters: that's part of what the caching the RPMs instead of

Evan Goode: So if you have a…

Evan Goode: if you're caching an RPM versus caching I don't know how it works in RPM O tree but you extract the RPM and get a tree of files from that an image maybe equivalently. how does that make a difference for I guess hermiticity for lack of a better word? is it not fine to just apply an RPM? I don't get how it connects to the zero drift kind of thing.

Colin Walters: No, no. Yeah. sorry. I'll link to the RPM Street page on this. It's basically so we cache the pristine files in the immutable object store,  And so how it connects to the zero drift thing is it becomes client side it's much a you can't accidentally mutate things but even with the kind of user overlay or even like a kind of persistent thing we make sure that we can always reassemble the pristine system or the system with the changes.

#### 00:45:00

Colin Walters: you wanted without redownloading the RPMs and B without accidentally leaking any state from your current system I guess today right with RPM is like you layer a package but then you want to go back to the golden image that's a cheap free operation right because we maintained the separate immutable file system trees and just in the case you want to go back to the base image we already have that tree we just check it out

Colin Walters: more right it's kind of like we maintain a different way to say what I'm talking about right is if you think about how an OCI image is a series of layers but in a limit right you can have multiple images that actually share layers because it's a content address store right at that level and so just it's basically think about unpacking an RPM as one of those layers that's kind of like without running its post scripts.

Colin Walters: That is basically what we do.

Evan Goode: Yeah, the scripts are the big problem I see and…

Evan Goode: I'm understanding the rationale for storing unpacked RPMs for the space saving concerns if we hard link all the f use a fancy content addressed system. but yeah, I guess I'm trying to think about how this maps on to DNF since DNF just has a directory where it sticks all of the cache RPMs in and by default we wipe that directory after the transactions done so it doesn't take up unnecessary space.

Evan Goode: but I guess the idea here is that directory is var cache something. So that's already going to be unified to some extent. every time you run DNF on that system, it's going to be looking in that cache for RPMs. so it's the only difference in what you're talking about that we sort of unpack and dduplicate those. Yeah.

Colin Walters: Yes, kind of. I mean the difference between compressed and uncompressed is huge here because it's the difference between duplicating space or not. which at a certain point and scale and you're just talking about all the duplicate IO, it's a really big deal. yeah, as far as efficiency, and I'm trying to address the second question. but it's also about the level of caching or garbage collection you think of, I'm going to figure out how to say this, I think to me it's a corporate wall. I always want to be able to switch back to the golden base image.

Colin Walters: get back to the state I want without maybe even needing network. If we just think of it as a cache that can be redownloaded sometimes like that, yeah, that can create some unpredictability, Whereas the way RP3 works today is it maintains strong references to all those cached unpacked packages as long as they're referenced by any deployment which means We only touch the network when we need to I guess and we don't garbage collect things.

Evan Goode: I see that.

Colin Walters: Yeah. Yeah.

Evan Goode: That's the missing thing I was not understanding. Cool. Yeah, I wonder how that would work in the DNF context. cuz we are aware of the RPM database and…

Dusty Mabe: 

Evan Goode: also where the packages came from somewhat.

Evan Goode: something to think about.

Colin Walters: The way I describe this in a nutshell is RPM has a lot of cool features. and some things work amazingly, some things don't work as well. And it's been really confusing over the years to see people try and navigate this and understand what they should expect to work and…

#### 00:50:00

Colin Walters: what not. And if we can get to the point where again I type a DF command and the least surprising thing happens like that, that's really what I'd love to see. and addition

Dusty Mabe: So I think we were focusing in is something driving boot C or…

Dusty Mabe: is boot C driving something else for the local layering and Colin I think you said you were advocating for something else is driving boot C. Is that right? So let's talk through that briefly. because we talked through the other case earlier. So in the case that something else is driving boot C, what happens when there's a new update available?

Dusty Mabe: Who's checking that?

Colin Walters: and you update to base image, a package, nonRPM content, all of the above,…

Dusty Mabe: Yeah, just an update to the container that the system's following in a registry repo like Quay. Yes.

Colin Walters: the base image. Yeah. But sorry, just one really brief tangent on this, but it's actually an important one. bootc has gained logically about images and I keep singing their praises but because it actually fundamentally changes the character of the system from I have one container image that I'm tracking to I have multiple which is not a small thing at all and it's actually really re very relevant to this because it's very helpful to split things out in logically bound images and decouple your operating system state from the base update and kind of keep your system minimal.

Colin Walters: And I'd actually love if we had a good story for enable logically bound images locally because that has some cool advantages. just mentioning all that just as a background but yes, the sort of base image update is obviously important in all this. so yeah, I mean I think the simple answer is I mean this kind of circles to use the unified storage question,  If we had unified storage, then it doesn't matter whether it's a podman pull or a boot seat pull unfortunately because it does matter. unless sorry going into a lot of unnecessary detail we could teach hot man how to use the booty storage for builds and stuff. Sorry it's hard.

Colin Walters: So I think maybe if we say we have unified storage we can hope maybe we can predicate this on that then it kind of doesn't matter.

Dusty Mabe: Yeah. Assume we have unified storage.

Dusty Mabe: So that's not necessarily a problem. what is the face I guess not the interface for the user because they already did the local layering but now an update is available.

Colin Walters: So yeah,…

Dusty Mabe: How do the different pieces on the system that are responsible for the different things, who's responsible for what?

Colin Walters: I think it's actually very simple to say in the current design,…

Dusty Mabe: Who's responsible for checking if an update to the base image is available now?

Colin Walters: right? Bootsy only supports tracking one container image. And so if you want to boot something you built locally, the simplest way is, you bootcc switch to container storage, in which case you type booty upgrade,…

Dusty Mabe: Right.

Colin Walters: it's going to be like, the image didn't change in the pod man store, right? yeah. you get and a different way to say answer what your question, right, is booty does not expose today that ability to say I'm booted from this thing I built locally but pretend but the base image is actually from here and check for it it doesn't have that concept. we could certainly make it and in the open containers annotations there is an annotation to say I was built from this base image So in theory because sorry without just real briefly on more detail right when you do an OCI build like that concept of what you're from is kind of lost actually by default without this annotation. you just don't know. yeah.

Dusty Mabe: Go ahead.

Evan Goode: I'm thinking this could be as simple as some binary flag like the bootc knows is some other tool doing the local layering or…

#### 00:55:00

Evan Goode: am I doing the upgrade stuff maybe a reference to what that tool is and that way if you type upgrade, bootc doesn't have to worry about checking the registries or worrying about where the local container was built from. and it only calls out to that local tool to do the polling and rebuilding.

Dusty Mabe: So in other words, it wouldn't be necessarily a plugin. It's just like whatever the local user decided to use they would just basically run a new podman build or whatever and if there's a new thing then a new layer will get created and then it will talk to boot C or the user will talk to boot C to tell it there's a new thing that exists.

Dusty Mabe: Is that right?

Evan Goode: I suppose that's in the second case here…

Evan Goode: where something else is driving bootsy I guess that other tool would be calling out to bootsy a user would call this tool maybe it's a plugin DNF system rebuild and then that calls bootsy but yeah that leaves open the question of what if the user wants to initiate it with bootc upgrade and then having Bootsy be aware of that. It's like a I don't know

Dusty Mabe: Yeah, I think my only problem there is we have discussed a few different you put in your stuff in a container file, right? And then you also can have some DNF things that you've fied. So RPMs that are slightly different and then another option is you have overrides root FS type where you've just dropped in the actual directory within the file system where they're supposed to be. I don't think necessarily we can get all of that if boots is not the driver or maybe it depends on the local layering tool.

Dusty Mabe: So at some point something needs to integrate all of those things. And so whether it's bootc talking to the integrator who then hands it back the container to update to or if it's the user interacting directly with the integrator who then talks to bootsy. I think that's a fundamental question of what we think is a better user experience. obviously we should discuss how difficult each approach should be as well but assuming they're similarly difficult the user experience should probably win out which one's a better user experience I don't know I think Jason had to drop obviously we're going a little over do I guess we can try to you

Dusty Mabe: pick this discussion up and continue it at some point. this forum is fine with me some other forum's fine as well as long as we are happy to keep having that talk because I'm really interested in this feature. I'll definitely try to keep driving conversations forward on it.

Colin Walters: Yeah, I think let's Yeah,…

Colin Walters: we should just copy or maybe refine the notes into the tracker issue and keep this up. I think there's a lot of good things here. Unfortunately, I do need to drop but yes, I'm definitely glad we had this one.

Dusty Mabe: Cool. Thanks everybody for joining and…

Dusty Mabe: taking part.

Colin Walters: Awesome. Thanks all.

#### Meeting ended after 00:59:09 👋

*This editable transcript was computer generated and might contain errors. People can also change the text after it was created.*

*jbrooks changed all instances of “Bootsie” to bootc and adjusted heading depth*
